<?php
if ( ! defined( 'ABSPATH' ) ) {
  exit;
}

function vmv_preloader_option_defaults() {
  $array = array(
    'pluginActivated'             => false,
    'delete_option_on_deactivate' => false,
    'viewEachLoad'                => false, // sessionStorage, localStorage

    'logoText'          => 'Your name',
    'logoTextPrevious'  => '',
    'fill1'             => '#EBEBEB',
    'fill2'             => '#EBEBEB',
    'fill3'             => '#EBEBEB',
    'shadow'            => 'rgba(0, 0, 0, 0.8)',
    'bgBody'            => '#004E98',
    'bgStop1'           => '#5D9CDF',
    'bgStop2'           => '#004E98',
    'gradientType'      => 'radial',
    'gradientDirection' => 'at top',
    'w1'                => 80,
    'w2'                => 70,
    'w3'                => 50,
    'w4'                => 50,
    'timeStamp'         => 1644573315,
    'timeDelay'         => 1,
    'speedRatio'        => 6,

    'SVGWidth'             => 0,
    'SVGHeight'            => 55,
    'pulseLeft'            => 0,
    'pulseBottom'          => - 10,
    'pulseWidth'           => 25,
    'pulseIsCustom'        => false,
    'customPulseStyle'     => '',
    'customPulseHtml'      => '',
    'customPulseScript'    => '',
    'pulseCustomElement'    => '',
    'uniqCorrectSpeedDraw' => 1,
    'themeFile'            => 'SignatureFont.json',

    'strategyHide'  => 'end', // ['end', 'fullLoad']
    'previewIdPage' => null,

    'pluginOptionsLogoText'        => true,
    'pluginOptionsFillColorSecond' => false,

    'isPremium' => false,

    'vmvBgIsActive' => false,
    'vmvBgData'     => '',
    'dataLetters'   => '',

    'premiumDataSVG'            => '',
  );

  return $array;
}

function vmv_preloader_get_option() {
  return get_option( VMV_ONE__OPTION );
}

// send only needed options
function vmv_preloader_get_option_front() {
  $option = get_option( VMV_ONE__OPTION );
  unset( $option['logoTextPrevious'] );
  unset( $option['SVGWidth'] );
  unset( $option['SVGHeight'] );
  unset( $option['pulseLeft'] );
  unset( $option['pulseBottom'] );
  unset( $option['pulseWidth'] );
  unset( $option['pulseIsCustom'] );
  unset( $option['customPulseStyle'] );
  unset( $option['customPulseHtml'] );
  unset( $option['customPulseScript'] );
  unset( $option['uniqCorrectSpeedDraw'] );
  unset( $option['pulseCustomElement'] );
  unset( $option['premiumDataSVG'] );
  unset( $option['dataLetters'] );
  unset( $option['vmv_token'] );
  return $option;
}


function vmv_preloader_update_option( $new_option, $option ) {
  $updated_option = array_merge( $option, $new_option );
  $updated        = update_option( VMV_ONE__OPTION, $updated_option );

  return $updated == 1;
}

function vmv_preloader_option_exists() {
  if ( ! vmv_preloader_get_option() ) {
    return false;
  } else {
    return true;
  }
}

function vmv_preloader_update_settings() {
  if ( array_key_exists( '_wpnonce', $_POST ) ) {
    if ( ! wp_verify_nonce( $_POST['_wpnonce'], 'vmv_preloader_update_settings' ) ) {
      return false;
    } else {
      $option                           = vmv_preloader_get_option();
      $new_option                       = array();
      $new_option['title']              = sanitize_text_field( $_POST['title'] );
      $new_option['title_fill_color']   = sanitize_text_field( $_POST['title_fill_color'] );
      $new_option['title_stroke_color'] = sanitize_text_field( $_POST['title_stroke_color'] );

      if ( array_key_exists( 'delete_option_on_deactivate', $_POST ) ) {
        $new_option['delete_option_on_deactivate'] = sanitize_text_field( $_POST['delete_option_on_deactivate'] );
      } else {
        $new_option['delete_option_on_deactivate'] = $option['delete_option_on_deactivate'];
      }

      foreach ( $new_option as $key => $value ) {
        if ( $value !== $option[ $key ] ) {
          $update_option = 1;
        }
      }

      if ( isset( $update_option ) ) {
        if ( $update_option == 1 ) {
          $update = vmv_preloader_update_option( $new_option, null );

          return $update;
        }
      }
    }
  }
}